<?php
// Author: Kevin K.M. Chiu
// Copyright 2000, Cobalt Networks.  All rights reserved.
// $Id: personalAccountHandler.php,v 1.20 2002/03/21 03:02:22 pbaltz Exp $

include("ServerScriptHelper.php");

$serverScriptHelper = new ServerScriptHelper();
$cceClient = $serverScriptHelper->getCceClient();
$i18n = $serverScriptHelper->getI18n("base-user");
$loginName = $serverScriptHelper->getLoginName();

// get old settings
$user = $cceClient->getObject("User", array("name" => $loginName));

$attributes = array("fullName" => $fullNameField, "localePreference" => $languageField);
if($newPasswordField)
  $attributes["password"] = $newPasswordField;
if($styleField)
  $attributes["stylePreference"] = $styleField;

$cceClient->setObject("User", $attributes, "", array("name" => $loginName));
$errors = $cceClient->errors();

for ($i = 0; $i < count($errors); $i++) {
	if ( ($errors[$i]->code == 2) && ($errors[$i]->key === "password"))
	{
		$errors[$i]->message = "[[base-user.error-invalid-password]]";
	}
}


print($serverScriptHelper->toHandlerHtml("/base/user/personalAccount.php", $errors));

// reload browser window if style has changed
if(($cceClient->suspended() === false) && 
	(($styleField && $user["stylePreference"] != $styleField) || 
   	($languageField && $user["localePreference"] != $languageField))) 
{
  $reloadMessage = $i18n->getJs("reloadMessage");

  // need to set the encoding correctly or Japanese strings get murdered
  $encoding = $i18n->getProperty('encoding', 'palette');
  if ($encoding != 'none') {
	$encoding = "; charset=$encoding";
  } else {
	$encoding = "";
  }
?>
<HTML>
<HEAD>
<META HTTP-EQUIV="Content-type" CONTENT="text/html<?php print $encoding; ?>">
</HEAD>
<BODY>
<SCRIPT LANGUAGE="javascript">
var strReloadMessage = '<?php print $reloadMessage; ?>';
alert(strReloadMessage);
setTimeout("top.location.reload();", 2);
</SCRIPT>
</BODY>
</HTML>
<?
}

$serverScriptHelper->destructor();
?>
