<?php
// Author: Kevin K.M. Chiu
// Copyright 2000, Cobalt Networks.  All rights reserved.
// $Id: personalEmail.php,v 1.5 2001/12/07 03:02:12 pbaltz Exp $

include("ServerScriptHelper.php");
include("uifc/PagedBlock.php");

$serverScriptHelper = new ServerScriptHelper();
$cceClient = $serverScriptHelper->getCceClient();
$factory = $serverScriptHelper->getHtmlComponentFactory("base-user", "personalEmailHandler.php");
$loginName = $serverScriptHelper->getLoginName();

// get setting
$userEmail = $cceClient->getObject("User", array("name" => $loginName), "Email");

$page = $factory->getPage();

$block = new PagedBlock($page, "emailSettingsFor", $factory->getLabel("emailSettingsFor", false, array("userName" => $loginName)));
$block->processErrors($serverScriptHelper->getErrors());

$forwardEnable = $factory->getOption("forwardEnable", $userEmail["forwardEnable"]);
$forwardEnable->addFormField(
  $factory->getEmailAddressList("forwardEmailField", $userEmail["forwardEmail"]),
  $factory->getLabel("forwardEmailField")
);
$forwardEnable->addFormField(
  $factory->getBoolean("forwardSaveField", $userEmail["forwardSave"]),
  $factory->getLabel("forwardSaveField")
);

$forward = $factory->getMultiChoice("forwardEnableField");
$forward->addOption($forwardEnable);
$block->addFormField($forward, $factory->getLabel("forwardEnableField"));

$autoResponder = $factory->getMultiChoice("autoResponderField");
$enableAutoResponder = $factory->getOption("enableAutoResponderField", $userEmail["vacationOn"]);
$enableAutoResponder->addFormField(
  $factory->getTextBlock("autoResponderMessageField", $userEmail["vacationMsg"]),
  $factory->getLabel("autoResponderMessageField")
);
$autoResponder->addOption($enableAutoResponder);
$block->addFormField($autoResponder, $factory->getLabel("autoResponderField"));

$block->addButton($factory->getSaveButton($page->getSubmitAction()));

$serverScriptHelper->destructor();
?>
<?php print($page->toHeaderHtml()); ?>

<?php print($block->toHtml()); ?>

<?php print($page->toFooterHtml()); ?>
