<?php
// Author: Kevin K.M. Chiu
// Copyright 2000, Cobalt Networks.  All rights reserved.
// $Id: userAdd.php,v 1.55 2002/06/17 22:37:19 will Exp $

include_once("ArrayPacker.php");
include_once("ServerScriptHelper.php");
include_once("AutoFeatures.php");


$serverScriptHelper = new ServerScriptHelper();
$cceClient = $serverScriptHelper->getCceClient();
$factory = $serverScriptHelper->getHtmlComponentFactory("base-user", "/base/user/userAddHandler.php");
$i18n = $factory->i18n;

// slight efficiency gain
$errors = $serverScriptHelper->getErrors();
if (count($errors) == 0)
{
    // defaults
    if ($group)
    { 
        $defaults = $cceClient->getObject("Vsite", array("name" => $group), "UserDefaults");
    }
    else  
    {
        $defaults = $cceClient->getObject("System", array(), "UserDefaults");
    }
}

$page = $factory->getPage();
$form = $page->getForm();
$formId = $form->getId();

$block = $factory->getPagedBlock("addNewUser");
$block->addPage("account", $factory->getLabel("account"));
$block->setDefaultPage("account");
$block->setHideEmptyPages(array(""));
if ($group) {
  list($vsite) = $cceClient->find("Vsite", array("name" => $group));
  $vsiteObj = $cceClient->get($vsite);
  $block->setLabel($factory->getLabel('addNewUserTitle', false, array('fqdn' => $vsiteObj['fqdn'])));
}

if(count($errors) > 0)
{
    $block->processErrors($errors, array('fullName' => 'fullNameField', 'name' => 'userNameField', 'password' => 'passwordField', 'description' => 'userDescField', 'quota' => 'maxDiskSpaceField', 'capLevels' => 'siteAdministrator', 'aliases' => 'emailAliasesField'));
}

$block->addFormField($factory->getTextField("group", $group, ""),"","account");

$block->addFormField(
    $factory->getFullName("fullNameField", $fullNameField),
    $factory->getLabel("fullNameField"),
    "account"
);

$prop=$i18n->getProperty("needSortName");
if($prop=="yes"){
	    $sortName=$factory->getFullName("sortNameField", $sortNameField);
	    $sortName->setOptional('silent');
	    $block->addFormField(
	            $sortName,
                $factory->getLabel("sortNameField"),
		"account"
	);
}

$block->addFormField(
    $factory->getUserName("userNameField", $userNameField),
    $factory->getLabel("userNameField"),
    "account"
);

$block->addFormField(
    $factory->getPassword("passwordField", $passwordField),
    $factory->getLabel("passwordField"),
    "account"
);

// Load site or disk quota
if ($group)
{
print $group."<P><HR>";
    list($vsite_oid) = $cceClient->find('Vsite', array("name" => $group));
    $disk = $cceClient->get($vsite_oid, 'Disk');
    $max_quota = $disk['quota'];
}
else
{
    list($home_oid) = $cceClient->find('Disk', 
        array("mountPoint" => "/home"));
    $disk = $cceClient->get($home_oid);
    $max_quota = intval(intval($disk['total']) / 1024);
}

$site_quota = ($max_quota == -1 ? 499999999 : $max_quota);

$quota = $factory->getInteger(
			"maxDiskSpaceField", 
			($defaults['quota'] != -1 ? $defaults['quota'] : ""), 
			1, $site_quota);

// quota is not optional for site members on raqs
if (!isset($group)) {
	$quota->setOptional('silent');
}

// if($max_quota && $max_quota != -1)
    $quota->showBounds(1);

$block->addFormField(
    $quota,
    $factory->getLabel("maxDiskSpaceField"),
    "account"
);


// add other features
$autoFeatures = new AutoFeatures($serverScriptHelper);

if (isset($group) && $group != "") 
{
    list($userServices) = $cceClient->find("UserServices", array("site" => $group));
    list($vsite) = $cceClient->find("Vsite", array("name" => $group));
    $autoFeatures->display($block, "create.User", array("CCE_SERVICES_OID" => $userServices, "VSITE_OID" => $vsite));

    $block->addFormField(
        $factory->getBoolean("siteAdministrator", ""),
        $factory->getLabel("siteAdministratorField"),
        "account"
    );
 
}
else 
{
    list($userServices) = $cceClient->find("UserServices");
    $autoFeatures->display($block, "create.User", array("CCE_SERVICES_OID" => $userServices));
}

// make group list if Workgroup exists
$cceClient->names("Workgroup");
if (count($cceClient->errors()) == 0)
{
    $groups = $cceClient->getObjects("Workgroup");
    $groupNames = array();
    for($i = 0; $i < count($groups); $i++) 
    {
        $Wgroup = $groups[$i];
        $groupNames["$i"] = $Wgroup["name"];
    }
    $groupNamesString = arrayToString($groupNames);
 
    $groupSelector = $factory->getSetSelector("memberGroupsField", "", 
        $groupNamesString, "memberGroups", "allGroups");
    $groupSelector->setOptional(true);
    $block->addFormField(
        $groupSelector,
        $factory->getLabel("memberGroupsField"),
        "account"
    );
}
	
$emailAliases = $factory->getEmailAliasList("emailAliasesField");
$emailAliases->setOptional(true);
$block->addFormField(
    $emailAliases,
    $factory->getLabel("emailAliasesField"),
    "account"
);

$textblock = $factory->getTextBlock("userDescField", 
	                $i18n->interpolate($default["description"]));
$textblock->setWidth(2*$textblock->getWidth());
$textblock->setOptional(true);
$block->addFormField(
    $textblock,
    $factory->getLabel("userDescField"),
    "account"
);

$block->addButton($factory->getSaveButton($page->getSubmitAction()));
$block->addButton($factory->getCancelButton("/base/user/userList.php?group=$group"));

$serverScriptHelper->destructor();
?>
<?php print($page->toHeaderHtml()); ?>

<SCRIPT LANGUAGE="javascript" SRC="userNameGenerator.JS"></SCRIPT>
<SCRIPT LANGUAGE="javascript" SRC="emailAliasGenerator.JS"></SCRIPT>

<?php 
print($block->toHtml());
?>

<SCRIPT LANGUAGE="javascript">
var oldChangeHandler = document.<?php print($formId)?>.fullNameField.onchange;

function fullNameChangeHandler() {
  if(oldChangeHandler != null) {
    var ret = oldChangeHandler();
    if(!ret)
      return ret;
  }

  var form = document.<?php print($formId)?>;

  // generate user name
  if(form.userNameField.value == "")
    form.userNameField.value = userNameGenerator_generate(form.fullNameField.value, "<?php print($defaults["userNameGenMode"]) ?>");

  // generate email alias
  if(form.emailAliasesField.textArea.value == "") {
    var alias = emailAliasGenerator_generate(form.fullNameField.value);
    if(alias != form.userNameField.value)
      form.emailAliasesField.textArea.value = alias;
  }
}
<?php
if($i18n->getProperty("genUsername")=="yes"){
	print("document.$formId.fullNameField.onchange = fullNameChangeHandler;\n");
}
?>
</SCRIPT>

<?php print($page->toFooterHtml()); ?>
