<?php
/*
 * Copyright 2000-2002 Sun Microsystems, Inc.  All rights reserved.
 * $Id: userList.php,v 1.68 2002/06/23 01:31:17 arlo Exp $
 */
include_once("ServerScriptHelper.php");
include_once("uifc/Button.php");
include_once("AutoFeatures.php");
include_once("ArrayPacker.php");
include_once("Capabilities.php");

$serverScriptHelper = new ServerScriptHelper();
$autoFeatures = new AutoFeatures($serverScriptHelper);
$cceClient = $serverScriptHelper->getCceClient();
$capabilities = new Capabilities($cceClient);
$factory = $serverScriptHelper->getHtmlComponentFactory("base-user", "/base/user/userList.php?group=$group");
$i18n = $serverScriptHelper->getI18n("base-user");

$page = $factory->getPage();
$form = $page->getForm();
$formId = $form->getId();

$defaults = $factory->getButton("javascript: location='/base/user/userDefaults.php?group=$group'; top.code.flow_showNavigation(false)", "userDefaults");

if ($group) {
	$userDefaults = $cceClient->getObject("Vsite", array("name" => $group), "UserDefaults");
	list($vsite) = $cceClient->find("Vsite", array("name" => $group));
	$vsiteObj = $cceClient->get($vsite);
    	list($userServices) = $cceClient->find("UserServices", array("site" => $group));
	$hiddenGroup = $factory->getTextField('group', $group, '');
} else {
	$userDefaults = $cceClient->getObject("System", array(), "UserDefaults");
	list($userServices) = $cceClient->find("UserServices");
}

$pageLength = ($userDefaults != null && $userDefaults["userlist_range"] > 0 ) ? $userDefaults["userlist_range"] : 25;

// generate search field
$searchBlock = $factory->getPagedBlock("userSearch");
$searchBlock->setColumnWidths(array("8%", "92%"));

$searchby = $factory->getMultiChoice("searchBy", array("userName", "fullName", "emailAlias"));

$searchTextField =& $factory->getTextField("searchtext");
$searchTextField->setOptional('silent');

$searchButton = $factory->getButton("javascript: document.$formId.isSearch.value = 1; document.$formId.submit();", "searchbut");

$searchField = $factory->getCompositeFormField(array($searchby, $searchTextField, $searchButton));

$searchBlock->addFormField($searchField, $factory->getLabel("userSearchCriteria"));

/*
 * add hidden form field to mark that a search is in progress to reset the page
 * index for the scroll list
 */
$searchBoolean =& $factory->getTextField('isSearch', 0, '');
$searchBoolean->setPreserveData(false);
$searchBlock->addFormField($searchBoolean);

// build the scroll list
$scrollList = $factory->getScrollList("userList", array("fullName", "userName", "emailAliases", "rights", "listAction"), array(1));
$scrollList->setAlignments(array("left", "left", "left", "left", "center"));
$scrollList->setColumnWidths(array("", "1%", "", "", "1%"));
$scrollList->setLength($pageLength);
if ($isSearch == 1) {
	$scrollList->setPageIndex(0);
}

$scrollList->processErrors($serverScriptHelper->getErrors());

if ($group) {
	$scrollList->setLabel($factory->getLabel('userListTitle', false, array('fqdn' => $vsiteObj['fqdn'])));
}

$addurl = "";

$addbutt = $factory->getAddButton(
        "javascript: location='/base/user/userAdd.php?group=$group';"
        . " top.code.flow_showNavigation(false)",
        "[[base-user.add_user_help]]"
	);
$addbutt->setHeader(true);

$scrollList->addButton($addbutt);

// disable sorting
$scrollList->setSortEnabled(false);

// find sort key
$sortBy = ($i18n->getProperty("needSortName") == "yes") ? "sortName" : "userName";

$sortKeyMap = array(0 => $sortBy, 1 => "name");
$sortKey = $sortKeyMap[$scrollList->getSortedIndex()];

// find start point
$start = $scrollList->getPageIndex() * $pageLength;
if ($group) {
	$exactMatch = array("site" => $group);
} else {
	$exactMatch = array();
}
$regexMatch = array();

$fieldMap = array('userName' => 'name', 'fullName' => 'fullName', 'emailAlias' => 'Email.aliases');
$field = $fieldMap[$searchBy];

if ($searchtext !== '') {
    $searchtext = preg_replace("/([][^$\{\}\|\+\.\?\*-])/", "\\\\$0", $searchtext);
    $regexMatch[$field] = makeCaseInsensitive($searchtext);
}

$oids = $cceClient->findx("User", $exactMatch, $regexMatch, 'ascii', $sortKey);

// sort in the right direction
if ($scrollList->getSortOrder() == "descending") {
	$oids = array_reverse($oids);
}

// admin is not a regular user, so we need to remove it
$adminOids = $cceClient->find("User", array("name" => "admin"));
$adminCount = 0;
for ($i = 0; $i < count($oids); $i++) {
	if($oids[$i] == $adminOids[0]) {
		$oids = array_merge(array_slice($oids, 0, $i),
				    array_slice($oids, $i+1));
		// number of users minus admin
		$adminCount++;
		break;
	}
}

for ($i = $start; $i < count($oids) && $i < $start + $pageLength; $i++) {
	$user = $cceClient->get($oids[$i]);
	$fullName = $user["fullName"];

	$userName = $user["name"];

	$userEmail = $cceClient->get($oids[$i], 'Email');
	$aliasStr = implode(', ', stringToArray($userEmail['aliases']));
	$aliases = $factory->getTextField('', $aliasStr, 'r');

	// Should use display options to dynamically include fields...
	// Comment out for now
	//  $desc = $factory->getTextField("", 
	//	$i18n->interpolate($user["description"]), "r");
	//  $desc->setMaxLength(80);	

	// Get the Style specific icon if one exists:
    $serverScriptHelper = new ServerScriptHelper();
	$stylist = $serverScriptHelper->getStylist();
	$style = $stylist->getStyle("UserStatusIcons");
	$inactiveUserIcon = $style->getProperty("inactiveUserIcon");
	
	// Check to see if the Style supports the icon:
	$displayInactiveUserIcon = ($inactiveUserIcon) ? $inactiveUserIcon : "/libImage/suspend_icon_small.gif";

	// Create user rights icons
	if (! $user['ui_enabled']) {
		$rights = array($factory->getImageLabel("userSuspended", $displayInactiveUserIcon));
	} else {
		$siteAdmin = ($capabilities->getAllowed('siteAdmin', $oids[$i]) ) ? $factory->getImageLabel("siteAdminEnabled", "/libImage/administrator.gif") : $factory->getImageLabel("blank", "/libImage/1pxblankIcon.gif", false);

		$rights = array($siteAdmin);
 
		if ($group) {
			$autoFeatures->display($rights, "list.User", array("VSITE_OID" => $vsite, "CCE_SERVICES_OID" => $userServices, "CCE_OID" => $oids[$i]));
    		} else {
			$autoFeatures->display($rights, "list.User", array("CCE_SERVICES_OID" => $userServices, "CCE_OID" => $oids[$i]));
		}
	}

	$scrollList->addEntry(
		array($factory->getFullName("", $fullName, "r"),
		      $factory->getUserName("", $userName, "r"),
		      $aliases,
		      $factory->getCompositeFormField($rights),
		      $factory->getCompositeFormField(
				array($factory->getModifyButton("javascript: location='/base/user/userMod.php?userNameField=$userName&group=$group'; top.code.flow_showNavigation(false)"),
      					$factory->getRemoveButton("javascript: confirmRemove('$userName')")
		))), "", false, $i);
}

$scrollList->setEntryNum(count($oids));

$serverScriptHelper->destructor();
?>
<?php print($page->toHeaderHtml()); ?>

<SCRIPT LANGUAGE="javascript">
function confirmRemove(userName) {
  var message = "<?php print($i18n->get("removeUserConfirm"))?>";
  message = top.code.string_substitute(message, "[[VAR.userName]]", userName);

  if(confirm(message))
    location = "/base/user/userRemoveHandler.php?userName="+userName<?php if ($group) print("+\"&group=$group\""); ?>;
}

// show flow buttons
if(top.code != null && top.code.flow_showNavigation != null)
  top.code.flow_showNavigation(true);
</SCRIPT>

<?php print $searchBlock->toHtml(); ?>
<BR>
<?php print($defaults->toHtml()); ?>
<BR>

<?php 

print($scrollList->toHtml());

if ($group) {
	print($hiddenGroup->toHtml());
}

print($page->toFooterHtml());

// create a case insensitive regular expression from the given string
function makeCaseInsensitive($string)
{
	return preg_replace("/([[:alpha:]])/e",
		"'[' . strtoupper('$1') . strtolower('$1') . ']'",
		$string);
}

?>
